

/*
   orxonox - the future of 3D-vertical-scrollers

   Copyright (C) 2004 orx

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   ### File Specific:
   main-programmer: Patrick Boenzli
   co-programmer:
*/
#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_WORLD_ENTITY


#include "npc_test.h"
#include <stdio.h>

#include "state.h"
#include "debug.h"

#include "loading/factory.h"
#include "loading/load_param.h"

#include "md2/md2Model.h"
#include "player.h"
#include "playable.h"

#include "class_id_DEPRECATED.h"
#include "movement_module.h"
#include "ai_module.h"
#include "ai_team.h"
#include "ai_swarm.h"
#include "ai_engine.h"

ObjectListDefinitionID(NPC2, CL_NPC_TEST2);
CREATE_FACTORY(NPC2);


NPC2::NPC2(const TiXmlElement* root) : NPC(NULL)
{
	this->registerObject(this, NPC2::_objectList);

	if (root != NULL)
		this->loadParams(root);

	std::cout << "Team Number: " << teamNumber << "\n";
	std::cout << "Swarm Number:" << swarmNumber << "\n";

	AITeam* myTeam=AIEngine::getInstance()->getCreateTeam(teamNumber);
	//std::cout << "Testpoint 4: " << myTeam << "\n";
	AISwarm* mySwarm=myTeam->getCreateSwarm(swarmNumber);
	//std::cout << "Testpoint 5: " << mySwarm << "\n";
	mySwarm->addToSwarm(new MovementModule(this));

}



void NPC2::loadParams(const TiXmlElement* root)
{
  NPC::loadParams(root);

  LoadParam(root, "team", this, NPC2, setTeamNumber)
		.describe("this sets the team number")
		.defaultValues(0);

  LoadParam(root, "swarm", this, NPC2, setSwarmNumber)
		.describe("this sets the swarm number")
		.defaultValues(0);
}



void NPC2::tick(float dt)
{
	// animating the md2 model
	if( likely(this->getModel(0) != NULL) && this->getModel(0)->isA(MD2Model::staticClassID()))
		((MD2Model*)this->getModel(0))->tick(dt);
}



